"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _isPromise = _interopRequireDefault(require("is-promise"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var DefaultLoadingComponent = function DefaultLoadingComponent() {
  return null;
};

var DefaultErrorComponent = function DefaultErrorComponent() {
  return null;
};

var version = _react.default.version;
var majorVersion = version ? Number.parseInt(version.slice(0, version.indexOf('.'))) : 0;

var AsyncComponent =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(AsyncComponent, _Component);

  function AsyncComponent(props) {
    var _this;

    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this, props].concat(args)) || this;

    _this.updateProgress = function (propName) {
      return function (progress) {
        var _objectSpread2;

        return _this.setState({
          progress: _objectSpread({}, _this.state.progress, (_objectSpread2 = {}, _objectSpread2[propName] = progress, _objectSpread2))
        });
      };
    };

    _this.errorComponent = null;
    _this.state = {
      error: null,
      loading: true,
      resolvedProps: {},
      progress: (0, _utils.fromPairs)(Object.keys(props.asyncProps || {}).map(function (k) {
        return [k, 0];
      }))
    };
    return _this;
  }

  var _proto = AsyncComponent.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.mounted = true;
    this.load();
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.mounted = false;
  };

  _proto.load = function load() {
    var _this2 = this;

    var pairs = (0, _utils.toPairs)(this.props.asyncProps || {}).filter(function (entry) {
      return entry[1];
    });

    if ((0, _utils.some)(pairs, function (entry) {
      return !(0, _utils.isFunction)(entry[1]);
    })) {
      this.setState({
        error: new Error('The prop of asyncProps must be a function.'),
        loading: false
      });
      return;
    }

    var batch = this.props.batch;
    pairs = pairs.map(function (_ref) {
      var k = _ref[0],
          v = _ref[1];
      return [k, v(_this2.updateProgress(k))];
    });

    if ((0, _utils.some)(pairs, function (pair) {
      return (0, _isPromise.default)(pair[1]);
    })) {
      var promises = pairs.map(function (_ref2) {
        var k = _ref2[0],
            p = _ref2[1];

        if ((0, _isPromise.default)(p)) {
          return p.then(function (res) {
            if (!batch) {
              if (_this2.mounted) {
                var _AsyncComponent$updat;

                _this2.setState(AsyncComponent.updateResolvedProps((_AsyncComponent$updat = {}, _AsyncComponent$updat[k] = res, _AsyncComponent$updat)));
              } else {
                _this2.state.resolvedProps[k] = res;
                _this2.state.progress[k] = 1;
              }
            }

            return [k, res];
          });
        }

        return [k, p];
      });
      Promise.all(promises).then(function (pairs) {
        if (_this2.mounted) {
          _this2.setState({
            resolvedProps: (0, _utils.fromPairs)(pairs),
            progress: (0, _utils.fromPairs)(pairs.map(function (_ref3) {
              var k = _ref3[0];
              return [k, 1];
            })),
            error: null
          });
        } else {
          _this2.state.resolvedProps = (0, _utils.fromPairs)(pairs);
          _this2.state.progress = (0, _utils.fromPairs)(pairs.map(function (_ref4) {
            var k = _ref4[0];
            return [k, 1];
          }));
          _this2.state.error = null;
        }
      }).catch(function (e) {
        if (_this2.mounted) {
          _this2.setState({
            error: e
          });
        } else {
          _this2.state.error = e;
        }
      }).finally(function () {
        if (_this2.mounted) {
          _this2.setState({
            loading: false
          });
        } else {
          _this2.state.loading = false;
        }
      });
    }
  };

  _proto.render = function render() {
    var _props = this.props,
        ErrorComponent = _props.errorComponent,
        LoadingComponent = _props.loadingComponent,
        Comp = _props.component,
        children = _props.children;
    var _state = this.state,
        error = _state.error,
        loading = _state.loading,
        resolvedProps = _state.resolvedProps,
        progress = _state.progress;

    var ignored = resolvedProps.children,
        restResolvedProps = _objectWithoutProperties(resolvedProps, ["children"]);

    if (loading) {
      return _react.default.createElement(LoadingComponent, _extends({}, this.props, restResolvedProps, {
        progress: progress
      }));
    }

    if (error) {
      return _react.default.createElement(ErrorComponent, _extends({}, this.props, restResolvedProps, {
        progress: progress,
        error: error
      }));
    }

    if (Comp) {
      return _react.default.createElement(Comp, _extends({}, this.props, resolvedProps, {
        progress: progress
      }));
    } // noinspection JSUnresolvedFunction JSCheckFunctionSignatures


    var newChildren = _react.default.Children.map(children, function (child) {
      return _react.default.cloneElement(child, restResolvedProps);
    });

    if (newChildren.length === 1) {
      return newChildren[0];
    } else if (newChildren.length > 1) {
      return majorVersion >= 16 ? newChildren : _react.default.createElement("div", null, " ", newChildren, " ");
    }

    return null;
  };

  return AsyncComponent;
}(_react.Component);

AsyncComponent.updateResolvedProps = function (resolvedProps) {
  return function (preState) {
    return {
      resolvedProps: _objectSpread({}, preState.resolvedProps, resolvedProps),
      progress: _objectSpread({}, preState.progress, (0, _utils.fromPairs)(Object.keys(resolvedProps).map(function (k) {
        return [k, 1];
      })))
    };
  };
};

var bool = _propTypes.default.bool,
    object = _propTypes.default.object,
    func = _propTypes.default.func,
    oneOfType = _propTypes.default.oneOfType,
    arrayOf = _propTypes.default.arrayOf,
    element = _propTypes.default.element; // noinspection JSUnresolvedVariable

AsyncComponent.propTypes = {
  batch: bool,
  // eslint-disable-next-line react/forbid-prop-types
  asyncProps: object.isRequired,
  component: func,
  children: oneOfType([element, arrayOf(element)]),
  errorComponent: func,
  loadingComponent: func
};
AsyncComponent.defaultProps = {
  batch: false,
  component: null,
  children: null,
  errorComponent: DefaultErrorComponent,
  loadingComponent: DefaultLoadingComponent
};
var _default = AsyncComponent;
exports.default = _default;
module.exports = exports["default"];